from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.EnhancedDiscussion import ed_globals
from cStringIO import StringIO
import string

cm="""threaded,Threaded
nested,Nested
minimal,Minimal
flat,Flat
dynamicThreaded,Dynamic Threaded
dynamicMinimal,Dynamic Minimal
none,None"""

skins=('enhanced-discussion','enhanced-discussion-subjecticons')

def install(self):
    out=StringIO()   
    out=install_skins(self,skins, out)
    out=install_misc(self,out)
    return out.getvalue()
        
def install_misc(self,out):
    ##Add site-wide comment options
    pt = getToolByName(self, 'portal_properties')
    sp = pt.site_properties
    
    if not sp.hasProperty('comment_modes'):
        sp.manage_addProperty(id='comment_modes', value=cm, type='lines')
        
    ##Add member_specific preferences
    mt = getToolByName(self, 'portal_memberdata')
    if not mt.hasProperty('pref_comment_mode'):
        mt.manage_addProperty(id='pref_comment_mode', value='dynamicMinimal', type='string')

    ##Add site-wide message types
    subjects = ['Agree','Disagree','Idea','Announcement','Summary','Question','Answer']
    mt = getToolByName(self,'portal_metadata')
    ##CHANGEME!!!
    try:
        mt.addElementPolicy( 'Subject', 'Discussion Item', 1, 0, [], 1, subjects)
    except:
        mt.updateElementPolicy('Subject','Discussion Item', 1, 0, [], 1,subjects)

    return out
                    
def install_skins(self,skins,out):
    skinstool = getToolByName(self, 'portal_skins')
    addDirectoryViews(skinstool, 'skins', ed_globals)

    present_skins = skinstool.getSkinSelections()
    for skin in present_skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        for dir in skins:
            if not dir in path:
                try:
                    idx = path.index( 'custom' )
                except ValueError:
                    idx = 999
                path.insert( idx+1, dir )

        path = string.join(path, ', ')
        # addSkinSelection will replace existing skins as well.
        skinstool.addSkinSelection(skin, path)
    return out
                                  
def uninstall(self):
    pt = getToolByName(self,  'portal_properties')
    if pt.site_properties.hasProperty('comment_modes'):
        pt.site_properties.manage_delProperties(['comment_modes',])
    
    mt = getToolByName(self, 'portal_memberdata')
    if mt.hasProperty('pref_comment_mode'):
        mt.manage_delProperties(['pref_comment_mode'])